## files-archive

=== Makefile ===
#
# Directories
#
WORKDIR ?= $(CURDIR)

#
# Parameters
#
KRAFT_TOKEN ?= FILLME

#
# General configuration
#
REG     ?= ghcr.io
ORG     ?= project-flexos
EXPS    ?= fig-06_nginx-redis-perm \
           fig-07_nginx-redis-normalized \
           fig-08_config-poset \
           fig-09_iperf-throughput \
           fig-10_sqlite-exec-time \
           fig-11_flexos-alloc-latency \
           tab-01_porting-effort
IMAGES  ?= flexos-base \
           nginx \
           redis \
           flexos-ae-plot \
           flexos-ae-base
TARGETS ?= prepare \
           run \
           plot \
           clean \
           properclean

ifeq ($(KRAFT_TOKEN),)
define ERROR_MISSING_TOKEN


<!> Missing `KRAFT_TOKEN` environmental variable <!>

This variable is used to connect the command-line utility `kraft` to the GitHub
API and download additional Unikraft repositories.  To generate a new token,
go to https://github.com/settings/tokens/new and select permission:

  - repo:public_repo

Once you have generated this token, simply export it in your command-line, like
so:

  $$ export KRAFT_TOKEN=ghp_...

Once this is done, please re-run your command:

  $$ $(MAKE) $(MAKECMDGOALS)


endef
  $(error $(ERROR_MISSING_TOKEN))
endif

#
# Utility vars
#
# Prefix each docker image with `docker-` so it has a unique phony target
DIMAGES := $(addprefix docker-,$(IMAGES))
Q       ?= @

#
# Tools
#
DOCKER  ?= docker
CURL ?= curl

#
# Find shortname for experiment
#
# Params:
#   $1: The canonical name of the experiment, e.g. `fig-XX_short-desc`
#   $2: The desired returning element, 1 for `fig-XX` and 2 for `short-desc`
#
underscore  = $(word $(2),$(subst _, ,$(1)))

#
# Create a new experiment target
#
# Params:
#   $1: The common API target, e.g. `prepare` 
#   $2: The canonical name of the experiment, e.g. `fig-XX_short-name`
#
define create-exp-target
.PHONY: $(1)
$(1): $(1)-$(2)

.PHONY: $(2)
$(2): $(1)

.PHONY: $(1)-$(2)
$$(call underscore,$(2),1): $(1)-$(2)
$(1)-$$(call underscore,$(2),1): $(1)-$(2)
$(1)-$(2):
	$(Q)$(MAKE) -C $(WORKDIR)/experiments/$(2) $(1)
endef

#
# Targets
#
.PHONY: all
all: prepare run plot

.PHONY: prepare
prepare: docker

# Iterate over all experiments and all targets and provide an entrypoint for
# each, e.g. `prepare-fig-XX_short-desc` and `prepare-fig-XX`.
$(foreach EXP,$(EXPS), \
	$(foreach TARGET,$(TARGETS),$(eval $(call create-exp-target,$(TARGET),$(EXP))) \
))

.PHONY: docker
docker: $(DIMAGES)

.PHONY: $(DIMAGES)
$(DIMAGES): TAG ?= latest
$(DIMAGES):
	$(Q)$(DOCKER) build \
		--tag $(REG)/$(ORG)/$(@:docker-%=%):$(TAG) \
		--build-arg UK_KRAFT_GITHUB_TOKEN="$(KRAFT_TOKEN)" \
		--file $(WORKDIR)/support/dockerfiles/Dockerfile.$(@:docker-%=%) \
		$(WORKDIR)/support

# Prepare the final Zenodo archive
zenodo:
	mkdir -p $(WORKDIR)/repositories
	# clone all repos in the flexos organization
	cd $(WORKDIR)/repositories && \
		$(CURL) -s https://github.com:@api.github.com/orgs/${ORG}/repos?per_page=200 | \
		jq .[].ssh_url | xargs -n 1 git clone
	# remove this one otherwise we'd be duplicate
	rm -rf repositories/asplos22-ae
	tar -czf $(WORKDIR)/../flexos-asplos22-ae.tar.gz $(WORKDIR)

dependencies: docker
	apt install time jq

=== experiments/fig-06_nginx-redis-perm/Makefile ===
#
# Files and directories
#
REG              ?= ghcr.io
ORG              ?= project-flexos
WORKDIR          ?= $(CURDIR)
RESULTSDIR       ?= $(WORKDIR)/results
TMPDIR           ?= /tmp/$(notdir $(WORKDIR))
APPSDIR          ?= $(WORKDIR)/apps
PLOT_FORMAT      ?= svg
PLOT             ?= $(WORKDIR)/$(notdir $(WORKDIR)).$(PLOT_FORMAT)
TAG              ?= latest
Q                ?= @

#
# Experiment variables
#
WAYFINDER_CORES  ?= 1,2
HOST_CORES       ?= 3,4
APPS             ?= nginx redis
NUM_COMPARTMENTS ?= 3
TEST_ITERATIONS  ?= 1

#
# Tools
#
SNAKE            ?= python3
WGET             ?= wget
APT              ?= apt
MKDIR            ?= mkdir -p
WAYFINDER        ?= $(TMPDIR)/wayfinder/dist/wayfinder
RM               ?= rm
TASKSET          ?= taskset
TOTALCPUS        ?= $(lscpu | grep '^CPU(s):' | awk '{ print $$2 }')
YTT              ?= ytt
# Tools
DOCKER           ?= docker
DOCKER_RUN       ?= $(DOCKER) run --rm $(2) \
                      $(foreach E, $(shell printenv), -e "$(E)") \
                      --entrypoint "" \
                      -w $(WORKDIR) \
                      -v $(WORKDIR):$(WORKDIR) \
                      $(REG)/$(ORG)/$(1):$(TAG) \
                        $(3)
CAT              ?= cat
JQ               ?= jq
GCC              ?= gcc
GIT              ?= git

#
# Targets
#
.PHONY: all
all: prepare run plot

.PHONY: prepare
prepare: install-wayfinder
prepare: install-deps
prepare: prepare-templates

.PHONY: install-deps
install-deps:
	$(APT) update
	$(APT) install --no-install-recommends \
		bridge-utils \
		net-tools \
		socat \
		uuid-runtime \
		wrk \
		redis-tools \
		jq

# If run with DOCKER= or within a container, unset DOCKER_RUN so all commands
# are not proxied via docker container.
ifeq ($(DOCKER),)
DOCKER_RUN    :=
else ifneq ($(wildcard /.dockerenv),)
DOCKER_RUN    :=
endif
.DOCKER_PROXY :=
ifneq ($(DOCKER_RUN),)
.DOCKER_PROXY := docker-proxy-
prepare-wayfinder-app-%:
	$(info Running target via $(REG)/$(ORG)/flexos-base:$(TAG)...)
	$(Q)$(call DOCKER_RUN,flexos-base,,$(MAKE) $@)
plot-app-%:
	$(info Running target via $(REG)/$(ORG)/flexos-ae-plot:$(TAG)...)
	$(Q)$(call DOCKER_RUN,flexos-ae-plot,,$(MAKE) $@)
endif

#
# Create preparation step for an application
#
# Params:
#   $1: The application name
#
define prepare-wayfinder-app

# This is an entry which is used to generate a job file to be used by Wayfinder.
# The job file creates all the possible permutations which will result in a
# unique unikernel binary image.
.PHONY: $$(.DOCKER_PROXY)prepare-wayfinder-app-$(1)
$$(.DOCKER_PROXY)prepare-wayfinder-app-$(1): $$(APPSDIR)/$(1)/wayfinder-jobs/$$(NUM_COMPARTMENTS).yaml
$$(APPSDIR)/$(1)/wayfinder-jobs/$$(NUM_COMPARTMENTS).yaml:
	$$(YTT) \
		--data-value num_compartments=$$(NUM_COMPARTMENTS) \
		--file $$(APPSDIR)/$(1)/templates/wayfinder > $$(APPSDIR)/$(1)/wayfinder-jobs/$$(NUM_COMPARTMENTS).yaml

# Make the general preparation step have these dynamic entries as dependents
prepare-templates: prepare-wayfinder-app-$(1)

# Make the general run step have these dynamic entries as dependents
run-wayfinder: run-wayfinder-app-$(1) test-app-$(1)

# This is an entry which is used to create a unique run-entry for the app,
# allowing you to run a specific application (and thus its permutations).  We
# set the working directory (-w) on wayfinder within the /tmp folder, as this
# will significantly speed up builds.  Please ensure you have enough RAM or
# set an alternative path via:
#
#  $ make TMPDIR=/path/to/dir run-wayfinder
#
# Also, cores have been hard-coded, please adjust according to your machine, and
# again, set accordingly, e.g.:
#
#  $ make HOST_CORES="3,12,24" run-wayfinder
#
.PHONY: run-wayfinder-app-$(1)
run-wayfinder-app-$(1):
ifeq ($$(WAYFINDER_CORES),)
	$$(WAYFINDER) -v run \
		--cpu-sets $$(HOST_CORES) \
		-w $$(TMPDIR)/wayfinder-build-$(1)/ \
		$$(APPSDIR)/$(1)/wayfinder-jobs/$$(NUM_COMPARTMENTS).yaml
else
	$$(TASKSET) -c $$(WAYFINDER_CORES) \
	$$(WAYFINDER) -v run \
		--cpu-sets $$(HOST_CORES) \
		-w $$(TMPDIR)/wayfinder-build-$(1)/ \
		$$(APPSDIR)/$(1)/wayfinder-jobs/$$(NUM_COMPARTMENTS).yaml
endif

# Target to run the test script on all permutations
.PHONY: test-app-$(1)
test-app-$(1): $$(RESULTSDIR)
test-app-$(1): RESULTS ?= $$(RESULTSDIR)/$(1).csv
test-app-$(1): UNIKERNEL_INITRD ?= $$(APPSDIR)/$(1)/$(1).cpio
test-app-$(1):
	ITERATIONS=$$(TEST_ITERATIONS) \
	RESULTS=$$(RESULTS) \
	UNIKERNEL_INITRD=$$(UNIKERNEL_INITRD) \
		$$(APPSDIR)/$(1)/test.sh $$(TMPDIR)/wayfinder-build-$(1)/results

# Create the list of permutations file
plot: $$(APPSDIR)/$(1)/permutations-$$(NUM_COMPARTMENTS).csv
plot: plot-app-$(1)
$$(APPSDIR)/$(1)/permutations-$$(NUM_COMPARTMENTS).csv:
	$$(CAT) $$(TMPDIR)/wayfinder-build-$(1)/results/tasks.json | \
		$$(JQ) -r '(["TASKID"] + keys[0] as $$$$k | .[$$$$k] | keys_unsorted) as $$$$cols | to_entries | map([.key, .value[]]) as $$$$rows | $$$$cols,$$$$rows[] | @csv' > \
			$$@

# Create a plot entrypoint for the app
.PHONY: $$(.DOCKER_PROXY)plot-app-$(1)
$$(.DOCKER_PROXY)plot-app-$(1):
	$$(SNAKE) $$(APPSDIR)/$(1)/plot.py \
		$$(APPSDIR)/$(1)/permutations-$$(NUM_COMPARTMENTS).csv \
		$$(RESULTSDIR)/$(1).csv \
		$$(WORKDIR)/$$(notdir $$(WORKDIR))-$(1).$$(PLOT_FORMAT)

# Probide a target to clean up the experiment
.PHONY: properclean-wayfinder-app-$(1)
properclean: properclean-wayfinder-app-$(1)
properclean-wayfinder-app-$(1):
	$$(RM) -r $$(TMPDIR)/wayfinder-build-$(1)/

endef

$(foreach APP,$(APPS), \
	$(eval $(call prepare-wayfinder-app,$(APP))) \
)
 
.PHONY: install-wayfinder
install-wayfinder: $(TMPDIR)
install-wayfinder: WAYFINDER_VERSION=0.1.0
install-wayfinder: $(WAYFINDER)

$(WAYFINDER): $(TMPDIR)/wayfinder
	$(MAKE) -C $(TMPDIR)/wayfinder container
	$(MAKE) -C $(TMPDIR)/wayfinder build

$(TMPDIR)/wayfinder:
	$(GIT) clone --branch v$(WAYFINDER_VERSION) https://github.com/lancs-net/wayfinder.git $(TMPDIR)/wayfinder

$(TMPDIR):
	$(MKDIR) $@

$(RESULTSDIR):
	$(MKDIR) $@

.PHONY: run
run: run-wayfinder

.PHONY: run-wayfinder
run-wayfinder: WAYFINDER_CORES="1,2"
run-wayfinder:
	$(TASKSET) -c $(WAYFINDER_CORES) $(WAYFINDER)

.PHONY: plot
plot:

.PHONY: clean
clean:
	@-

.PHONY: properclean
properclean:
	$(RM) -f $(TMPDIR)

=== experiments/fig-07_nginx-redis-normalized/Makefile ===
#
# Files and directories
#
WORKDIR ?= $(CURDIR)
RESULTS ?= $(WORKDIR)
PLOT_FORMAT ?= svg
PLOT ?= $(WORKDIR)/$(notdir $(WORKDIR)).$(PLOT_FORMAT)

FIG6DIR ?= $(WORKDIR)/../fig-06_nginx-redis-perm/
REDIS_PERMS_CSV ?= apps/redis/permutations-3.csv
NGINX_PERMS_CSV ?= apps/nginx/permutations-3.csv
# Change to results/ to use your freshly run results
REDIS_RES_CSV ?= paperresults/redis.csv
NGINX_RES_CSV ?= paperresults/nginx.csv

#
# Tools
#
SNAKE ?= /usr/bin/python3
DOCKER ?= docker

#
# Targets
#
.PHONY: all
all: prepare run plot

.PHONY: prepare
prepare:
	@-

.PHONY: run
run:
	@-

.PHONY: plot
plot:
	rm -rf $(PLOT)
	$(DOCKER) run --rm -v $(WORKDIR):/out -v $(FIG6DIR):/fig6 --privileged -ti \
		ghcr.io/project-flexos/flexos-ae-plot $(SNAKE) /out/plot_scatter.py \
		/fig6/$(REDIS_PERMS_CSV) /fig6/$(NGINX_PERMS_CSV) \
		/fig6/$(REDIS_RES_CSV) /fig6/$(NGINX_RES_CSV)
	mv $(WORKDIR)/nginx-redis-scatter.svg $(PLOT)

.PHONY: clean
clean:
	rm -rf $(PLOT)

.PHONY: properclean
properclean: clean
	@-

=== experiments/fig-08_config-poset/Makefile ===
#
# Files and directories
#
WORKDIR ?= $(CURDIR)
RESULTS ?= $(WORKDIR)
PLOT_FORMAT ?= svg
PLOT ?= $(WORKDIR)/$(notdir $(WORKDIR)).$(PLOT_FORMAT)

#
# Targets
#
.PHONY: all
all: prepare run plot

.PHONY: prepare
prepare:
	@-

.PHONY: run
run:
	@-

.PHONY: plot
plot:
	./plot.sh $(PLOT_FORMAT) $(PLOT)

.PHONY: clean
clean:
	rm -rf $(PLOT)

.PHONY: properclean
properclean:
	rm -rf $(PLOT)

=== experiments/fig-09_iperf-throughput/Makefile ===
#
# Files and directories
#
WORKDIR ?= $(CURDIR)
RESULTS ?= $(WORKDIR)
PLOT_FORMAT ?= svg
PLOT ?= $(WORKDIR)/$(notdir $(WORKDIR)).$(PLOT_FORMAT)

#
# Parameters
#
KRAFT_TOKEN ?=
# These should be contiguous on the same NUMA node
NOISOLED_CPU1 ?= 1
NOISOLED_CPU2 ?= 2
NOISOLED_CPU3 ?= 3
NOISOLED_CPU4 ?= 4
ISOLED_CPU1 ?= 5
ISOLED_CPU2 ?= 6
ISOLED_CPU3 ?= 7

#
# Tools
#
GNUPLOT ?= gnuplot
DOCKER ?= docker

#
# Targets
#
.PHONY: all
all: prepare run plot

.PHONY: prepare
prepare:
	$(DOCKER) build -f $(WORKDIR)/flexos-iperf.dockerfile \
		--build-arg GITHUB_TOKEN="$(KRAFT_TOKEN)" \
		--tag flexos-iperf $(WORKDIR)

.PHONY: run
run:
	$(DOCKER) run --rm -v $(WORKDIR):/out --privileged \
		--security-opt seccomp:unconfined -ti flexos-iperf \
		/root/run.sh $(ISOLED_CPU1) $(ISOLED_CPU2) $(ISOLED_CPU3) \
		$(NOISOLED_CPU1) $(NOISOLED_CPU2) $(NOISOLED_CPU3) $(NOISOLED_CPU4)

.PHONY: plot
plot:
	rm -rf $(PLOT)
	$(DOCKER) run --rm -v $(WORKDIR):/out --privileged -ti \
		ghcr.io/project-flexos/flexos-ae-plot $(GNUPLOT) /out/iperf.plot
	mv $(WORKDIR)/iperf.svg $(PLOT)

.PHONY: clean
clean:
	rm -rf results $(PLOT)

.PHONY: properclean
properclean: clean
	$(DOCKER) image rm -f flexos-iperf
	$(DOCKER) image prune -f

=== experiments/fig-10_sqlite-exec-time/Makefile ===
#
# Files and directories
#
WORKDIR ?= $(CURDIR)
RESULTS ?= $(WORKDIR)
PLOT_FORMAT ?= svg
PLOT ?= $(WORKDIR)/$(notdir $(WORKDIR)).$(PLOT_FORMAT)

#
# Parameters
#
KRAFT_TOKEN ?=
ISOLED_CPU1 ?= 5
ISOLED_CPU2 ?= 6

#
# Tools
#
GNUPLOT ?= gnuplot
DOCKER ?= docker
TIME ?= /usr/bin/time

#
# Targets
#
.PHONY: all
all: prepare run plot

.PHONY: prepare
prepare:
	$(TIME) $(DOCKER) build -f $(WORKDIR)/flexos-sqlite.dockerfile \
		--build-arg GITHUB_TOKEN="$(KRAFT_TOKEN)" \
		--tag flexos-sqlite $(WORKDIR)

.PHONY: run
run:
	$(DOCKER) run --rm -v $(WORKDIR):/out --privileged \
		--security-opt seccomp:unconfined -ti flexos-sqlite \
		/root/run.sh $(ISOLED_CPU1) $(ISOLED_CPU2)

.PHONY: plot
plot:
	rm -rf $(PLOT)
	$(DOCKER) run --rm -v $(WORKDIR):/out --privileged -ti \
		ghcr.io/project-flexos/flexos-ae-plot $(GNUPLOT) /out/sqlite.plot
	mv $(WORKDIR)/sqlite.svg $(PLOT)

.PHONY: clean
clean:
	rm -rf results $(PLOT)

.PHONY: properclean
properclean: clean
	$(DOCKER) image rm -f flexos-sqlite
	$(DOCKER) image prune -f

=== experiments/fig-11_flexos-alloc-latency/Makefile ===
#
# Files and directories
#
WORKDIR ?= $(CURDIR)
RESULTS ?= $(WORKDIR)/results
PLOT_FORMAT ?= svg
PLOT-DSS ?= $(WORKDIR)/$(notdir $(WORKDIR))-a.$(PLOT_FORMAT)
PLOT-LATENCY ?= $(WORKDIR)/$(notdir $(WORKDIR))-b.$(PLOT_FORMAT)

#
# Parameters
#
KRAFT_TOKEN ?=
ISOLED_CPU1 ?= 5
ISOLED_CPU2 ?= 6

#
# Tools
#
GNUPLOT ?= gnuplot
DOCKER ?= docker
TIME ?= /usr/bin/time

#
# Targets
#
.PHONY: all
all: prepare run plot

.PHONY: prepare-flexos
prepare-flexos:
	$(TIME) $(DOCKER) build -f $(WORKDIR)/flexos-microbenchmarks.dockerfile \
		--build-arg GITHUB_TOKEN="$(KRAFT_TOKEN)" \
		--tag flexos-microbenchmarks $(WORKDIR)

linux-latency:
	git clone https://github.com/project-flexos/app-flexos-microbenchmarks.git
	mv app-flexos-microbenchmarks linux-latency

.PHONY: prepare-linux
prepare-linux: linux-latency
	$(TIME) make linux -C linux-latency

.PHONY: prepare
prepare: prepare-flexos prepare-linux

.PHONY: run-flexos
run-flexos:
	$(DOCKER) run --rm -v $(WORKDIR):/out --privileged \
		--security-opt seccomp:unconfined -ti flexos-microbenchmarks \
		/root/run.sh $(ISOLED_CPU1) $(ISOLED_CPU2)

.PHONY: run-linux
run-linux:
	mkdir -p $(RESULTS)
	$(WORKDIR)/tools/benchmark_linux.sh $(RESULTS) $(WORKDIR)/linux-latency $(ISOLED_CPU1)

.PHONY: run
run: run-flexos run-linux

.PHONY: plot
plot:
	rm -rf $(PLOT-LATENCY) $(PLOT-DSS)
	$(DOCKER) run --rm -v $(WORKDIR):/out --privileged -ti \
		ghcr.io/project-flexos/flexos-ae-plot $(GNUPLOT) /out/dss.plot
	mv $(WORKDIR)/dss.svg $(PLOT-DSS)
	$(DOCKER) run --rm -v $(WORKDIR):/out --privileged -ti \
		ghcr.io/project-flexos/flexos-ae-plot $(GNUPLOT) /out/latency.plot
	mv $(WORKDIR)/latency.svg $(PLOT-LATENCY)

.PHONY: clean
clean:
	rm -rf results $(PLOT-LATENCY) $(PLOT-DSS) linux-benchmark

.PHONY: properclean
properclean: clean
	$(DOCKER) image rm -f flexos-microbenchmarks
	$(DOCKER) image prune -f

=== experiments/tab-01_porting-effort/Makefile ===
#
# Files and directories
#
WORKDIR ?= $(CURDIR)
RESULTS ?= $(WORKDIR)
PLOT_FORMAT ?= svg
PLOT ?= $(WORKDIR)/$(notdir $(WORKDIR)).$(PLOT_FORMAT)

#
# Parameters
#
KRAFT_TOKEN ?=

#
# Tools
#
DOCKER ?= docker
TIME ?= /usr/bin/time

#
# Targets
#
.PHONY: all
all: prepare run plot

.PHONY: prepare
prepare:
	$(TIME) $(DOCKER) build -f $(WORKDIR)/flexos-porting.dockerfile \
		--build-arg GITHUB_TOKEN="$(KRAFT_TOKEN)" \
		--tag flexos-porting $(WORKDIR)

.PHONY: run
run:
	$(DOCKER) run --rm -v $(WORKDIR):/out --privileged \
		--security-opt seccomp:unconfined -ti flexos-porting bash

.PHONY: plot
plot:
	@-

.PHONY: clean
clean:
	@-

.PHONY: properclean
properclean:
	$(DOCKER) image rm -f flexos-porting
	$(DOCKER) image prune -f

=== repositories/app-flexos-example/Makefile ===
UK_ROOT ?= $(PWD)/../../unikraft
UK_LIBS ?= $(PWD)/../../libs
LIBS := $(UK_LIBS)/newlib:$(UK_LIBS)/tlsf:$(UK_LIBS)/flexos-example
all:
		@$(MAKE) -C $(UK_ROOT) A=$(PWD) L=$(LIBS)
$(MAKECMDGOALS):
		@$(MAKE) -C $(UK_ROOT) A=$(PWD) L=$(LIBS) $(MAKECMDGOALS)

=== repositories/app-flexos-microbenchmarks/Makefile ===
UK_ROOT ?= $(PWD)/../../unikraft
UK_LIBS ?= $(PWD)/../../libs
LIBS := $(UK_LIBS)/newlib:$(UK_LIBS)/tlsf:$(UK_LIBS)/flexos-microbenchmarks
all:
		@$(MAKE) -C $(UK_ROOT) A=$(PWD) L=$(LIBS)
$(MAKECMDGOALS):
		@$(MAKE) -C $(UK_ROOT) A=$(PWD) L=$(LIBS) $(MAKECMDGOALS)
linux:
	gcc main.c -o benchmark -DLINUX_USERLAND

=== repositories/app-iperf/Makefile ===
UK_ROOT ?= $(PWD)/../../unikraft
UK_LIBS ?= $(PWD)/../../libs
LIBS := $(UK_LIBS)/newlib:$(UK_LIBS)/tlsf:$(UK_LIBS)/lwip:$(UK_LIBS)/iperf
all:
		@$(MAKE) -C $(UK_ROOT) A=$(PWD) L=$(LIBS)
$(MAKECMDGOALS):
		@$(MAKE) -C $(UK_ROOT) A=$(PWD) L=$(LIBS) $(MAKECMDGOALS)

=== repositories/app-nginx/Makefile ===
UK_ROOT ?= $(PWD)/../../unikraft
UK_LIBS ?= $(PWD)/../../libs
LIBS := $(UK_LIBS)/pthread-embedded:$(UK_LIBS)/newlib:$(UK_LIBS)/lwip:$(UK_LIBS)/tlsf:$(UK_LIBS)/nginx
all:
		@$(MAKE) -C $(UK_ROOT) A=$(PWD) L=$(LIBS)
$(MAKECMDGOALS):
		@$(MAKE) -C $(UK_ROOT) A=$(PWD) L=$(LIBS) $(MAKECMDGOALS)

=== repositories/kraft/package/debian/changelog ===
unikraft-tools (0.4.0) unstable; urgency=medium

  * kraft v0.4.0 released
  * xen-guest: When debugging, do not exit on guest shutdown
  * run/qemu-guest: Remove PMU option from CPU feature flags
  * qemu-guest: When debugging, do not exit on guest shutdown
  * package: Move Dockerfiles to package/ directory.
  * make: Build from any directory.
  * kraft: perform pre-initialisation of platform cache.
  * kraft: Update README.md with information redirection.
  * kraft: Update MAINTAINERS list
  * kraft: Update Github URL.
  * kraft: Set UK_APPS environment default
  * kraft: Remove reference to volumes and networks (for now).
  * kraft: Remove reference to volumes and networks (for now).
  * kraft: Remove --workdir flag
  * kraft: Provide specification file choice order.
  * kraft: Provide more coherent build for Docker
  * kraft: Provide full context subcomponents.
  * kraft: Provide details on influential environmental variables.
  * kraft: Provide ability to not checkout a repository.
  * kraft: Provide a central constants file.
  * kraft: Projet serialization
  * kraft: Introduce `volume` and `network` directives and increase
    stability.
  * kraft: Introduce `run` directive in specification.
  * kraft: Include full environment in all exec calls.
  * kraft: Include MANIFEST.in to include specification JSON files.
  * kraft: Fix setting defconf Kconfig value for non object directives.
  * kraft: Fix missing gitdb dependency.
  * kraft: Fix missing gitdb dependency with GitPython upgrade
  * kraft: Fix missing constant in config.
  * kraft: Fix missing Click option type for mutually exclusive types.
  * kraft: Fix is_configured to return True.
  * kraft: Consolidate project constants.
  * kraft: Consolidate list/update.
  * kraft:  Introduce YAML specification system.
  * kraft/utils: Fix missing import.
  * kraft/utils: Do not fail for file duplication on recursive copies.
  * kraft/update: Re-introduce Kraft update command.
  * kraft/update: Actually perform a forced update
  * kraft/settings:  Introduce .kraftrc
  * kraft/scripts:  Introduce new kraft-net network helper and dir
    rename.
  * kraft/repository: Turn logger warning into debug.
  * kraft/repository: Sort version numbers before chosing latest
    release.
  * kraft/repository: Return the latest version of the repository.
  * kraft/repository: Handle potentially corrupt Git repositories.
  * kraft/repository: Handle inability to perform fetch.
  * kraft/repository: Fix recursion error and pre-emptive checkout
  * kraft/project: handle missing kraft.yaml file during init
  * kraft/project: Provide Unikraft make P flag for alt platform builds.
  * kraft/project: Idiomize method name.
  * kraft/project: Force fetch and prepare for all builds.
  * kraft/project: Fix ensure checkout before configure.
  * kraft/executor: Use push arguments to platform executors.
  * kraft/executor: Support qemu-guest architectures.
  * kraft/executor: Only use -t flags for QEMU.
  * kraft/executor: Fix executor extra arg appends.
  * kraft/executor: Fix command variable mapping.
  * kraft/executor: Extract archives into temp directories.
  * kraft/executor: Enable guest acceleration if host architeture does
    not match target architecture.
  * kraft/errors: Anglicised target architecture/platform mismatch
    errors.
  * kraft/docs: Update README with kraft --help.
  * kraft/docs: Accept current changes.
  * kraft/context: Correct default apps directory.
  * kraft/config: Fix infering library Kconfig name.
  * kraft/components: Provide a mechanic to retrieve the shortest
    version of a repository source.
  * kraft/components/volume: Save workdir.
  * kraft/components/repository: update known versions for all repo
    types
  * kraft/components/repository: Fix missing exception import.
  * kraft/components/repository: Fix against listing truly empty
    repositories.
  * kraft/components/network: Account for varying brctl outputs.
  * kraft/components/executor: Fix map final arguments into string.
  * kraft/components/executor: Fix map final arguments into string.
  * kraft/components/executor: Extract tarball 9pfs.
  * kraft/components/executor: Do not escape xen/qemu-guest arguments.
  * kraft/commands: Remove  command from source tree.
  * kraft/commands: Re-introduce kraft-list command.
  * kraft/commands: Prompt user for configuration override.
  * kraft/commands: Pass --dbg or -d for non-stripped unikernel.
  * kraft/commands: Introduce run command.
  * kraft/commands: Import DHCP server initializer in correct file.
  * kraft/commands: Fix broken subcommand invocation.
  * kraft/commands: Exit on failure.
  * kraft/commands/update: Update kraft repsitory location.
  * kraft/commands/up: Remove old dnsmasq options.
  * kraft/commands/up: Provide blank up command.
  * kraft/commands/up: Introducing `kraft up`
  * kraft/commands/up: Introduce template for  command.
  * kraft/commands/up: Clean up comments.
  * kraft/commands/run: Add help to platform option.
  * kraft/commands/run: Add help to platform option.
  * kraft/commands/run:  Provide choice listing for architecture and
    platform.
  * kraft/commands/list: Text and commenting.
  * kraft/commands/list: Option to display list as JSON.
  * kraft/commands/list: Fix wording.
  * kraft/commands/list:  Prefer to update if cache is stale.
  * kraft/commands/init: Intrduce init command.
  * kraft/commands/init: Fix template app and usage.
  * kraft/commands/init: Fix logic to determine preferred architecture
    or platform.
  * kraft/commands/init: Determine app name from directory if omitted.
  * kraft/commands/configure: Validate architecture and platform.
  * kraft/commands/configure: Rename menuconfig short flag to -k.
  * kraft/commands/configure: Remove statically known platforms.
  * kraft/commands/configure: Fix extra print.
  * kraft/commands/configure: Fix architecture and platform selection.
  * kraft/commands/configure: Do not prompt check for menuconfig.


=== repositories/kraft/package/debian/control ===
Source: unikraft-tools
Section: devel
Priority: optional
Maintainer: Alexander Jung <a.jung@lancs.ac.uk>
Build-Depends: debhelper (>= 9),
  python3,
  python3-dev,
  dh-virtualenv (>= 1.0),
  tar
Standards-Version: 3.9.5
Homepage: http://unikraft.org

Package: unikraft-tools
Conflicts: kraft
Architecture: all
Pre-Depends: dpkg (>= 1.16.1), ${misc:Pre-Depends}
Depends: ${misc:Depends},
  python3.5 | python3 (>= 3.5),
  python3-distutils | python3-distutils-extra,
  git,
  make,
  libncursesw5-dev,
  libyaml-dev,
  flex,
  git,
  wget,
  patch,
  gawk,
  socat,
  bison,
  unzip,
  uuid-runtime
Recommends: dnsmasq,
  qemu,
  qemu-kvm,
  sgabios
Description: Define, configure, build and run unikernel applications.
  To begin using Unikraft SDK you can use the command-line utility kraft, which
  is a companion tool used for defining, configuring, building, and running
  unikernel applications. With kraft you can seamlessly create a build
  environment for your unikernel and painlessly manage dependencies for its
  build.

=== repositories/kraft/package/debian/rules ===
#!/usr/bin/make -f
#
# Build Debian package using https://github.com/spotify/dh-virtualenv
#
# The below targets create a clean copy of the workdir via
# using "sdist", else "pip" goes haywire when installing from
# sourcedir ".", because that includes the debian build stage,
# and a recursive explosion ensues when symlinks are followed.
#
# It also ensures your MANIFEST is complete and at least covers
# all files needed for a release build.

# Increase trace logging, see debhelper(7) (uncomment to enable)
#DH_VERBOSE=1

export PYBUILD_NAME=unikraft-tools
export DH_VIRTUALENV_INSTALL_ROOT=/usr/share

SNAKE = /usr/bin/python3

DH_VENV_ARGS = --python=$(SNAKE) --upgrade-pip \
	--preinstall "setuptools>=38" --preinstall "wheel"

ifneq ($(HTTP_PROXY),)
DH_VENV_ARGS += --extra-pip-arg=--proxy=$(HTTP_PROXY)
else ifneq ($(http_proxy),)
DH_VENV_ARGS += --extra-pip-arg=--proxy=$(http_proxy)
endif

PACKAGE = $(shell dh_listpackages)
VERSION = $(shell $(SNAKE) setup.py --version)
SDIST_DIR = $(CURDIR)

.PHONY: clean build-arch override_dh_virtualenv override_dh_strip

clean:
	dh $@ $(DH_VENV_ARGS)

build-arch:
	dh $@ $(DH_VENV_ARGS) --sourcedir $(SDIST_DIR)

%:
	dh $@ --with python-virtualenv --sourcedir $(SDIST_DIR)

override_dh_virtualenv:
	dh_virtualenv $(DH_VENV_ARGS)

override_dh_python3:
	dh_python3 --shebang=$(SNAKE)
